CfnMetricStream L1 construct
Creates or updates a metric stream.
Metrics streams can automatically stream CloudWatch metrics to AWS destinations including Amazon S3 and to many third-party solutions. For more information, see Metric streams .
To create a metric stream, you must be logged on to an account that has the iam:PassRole permission and either the CloudWatchFullAccess policy or the cloudwatch:PutMetricStream permission.
When you create or update a metric stream, you choose one of the following:
- Stream metrics from all metric namespaces in the account.
- Stream metrics from all metric namespaces in the account, except for the namespaces that you list in
ExcludeFilters. - Stream metrics from only the metric namespaces that you list in
IncludeFilters.
When you create a metric stream, the stream is created in the running state. If you update an existing metric stream, the state does not change.
If you create a metric stream in an account that has been set up as a monitoring account in CloudWatch cross-account observability, you can choose whether to include metrics from linked source accounts in the metric stream.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_cloudwatch as cloudwatch } from 'aws-cdk-lib';
const cfnMetricStream = new cloudwatch.CfnMetricStream(this, 'MyCfnMetricStream', {
firehoseArn: 'firehoseArn',
outputFormat: 'outputFormat',
roleArn: 'roleArn',
// the properties below are optional
excludeFilters: [{
namespace: 'namespace',
// the properties below are optional
metricNames: ['metricNames'],
}],
includeFilters: [{
namespace: 'namespace',
// the properties below are optional
metricNames: ['metricNames'],
}],
includeLinkedAccountsMetrics: false,
name: 'name',
statisticsConfigurations: [{
additionalStatistics: ['additionalStatistics'],
includeMetrics: [{
metricName: 'metricName',
namespace: 'namespace',
}],
}],
tags: [{
key: 'key',
value: 'value',
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_cloudwatch as cloudwatch
cfn_metric_stream = cloudwatch.CfnMetricStream(self, "MyCfnMetricStream",
firehose_arn="firehoseArn",
output_format="outputFormat",
role_arn="roleArn",
# the properties below are optional
exclude_filters=[cloudwatch.CfnMetricStream.MetricStreamFilterProperty(
namespace="namespace",
# the properties below are optional
metric_names=["metricNames"]
)],
include_filters=[cloudwatch.CfnMetricStream.MetricStreamFilterProperty(
namespace="namespace",
# the properties below are optional
metric_names=["metricNames"]
)],
include_linked_accounts_metrics=False,
name="name",
statistics_configurations=[cloudwatch.CfnMetricStream.MetricStreamStatisticsConfigurationProperty(
additional_statistics=["additionalStatistics"],
include_metrics=[cloudwatch.CfnMetricStream.MetricStreamStatisticsMetricProperty(
metric_name="metricName",
namespace="namespace"
)]
)],
tags=[CfnTag(
key="key",
value="value"
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.cloudwatch.*;
CfnMetricStream cfnMetricStream = CfnMetricStream.Builder.create(this, "MyCfnMetricStream")
.firehoseArn("firehoseArn")
.outputFormat("outputFormat")
.roleArn("roleArn")
// the properties below are optional
.excludeFilters(List.of(MetricStreamFilterProperty.builder()
.namespace("namespace")
// the properties below are optional
.metricNames(List.of("metricNames"))
.build()))
.includeFilters(List.of(MetricStreamFilterProperty.builder()
.namespace("namespace")
// the properties below are optional
.metricNames(List.of("metricNames"))
.build()))
.includeLinkedAccountsMetrics(false)
.name("name")
.statisticsConfigurations(List.of(MetricStreamStatisticsConfigurationProperty.builder()
.additionalStatistics(List.of("additionalStatistics"))
.includeMetrics(List.of(MetricStreamStatisticsMetricProperty.builder()
.metricName("metricName")
.namespace("namespace")
.build()))
.build()))
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.CloudWatch;
var cfnMetricStream = new CfnMetricStream(this, "MyCfnMetricStream", new CfnMetricStreamProps {
FirehoseArn = "firehoseArn",
OutputFormat = "outputFormat",
RoleArn = "roleArn",
// the properties below are optional
ExcludeFilters = new [] { new MetricStreamFilterProperty {
Namespace = "namespace",
// the properties below are optional
MetricNames = new [] { "metricNames" }
} },
IncludeFilters = new [] { new MetricStreamFilterProperty {
Namespace = "namespace",
// the properties below are optional
MetricNames = new [] { "metricNames" }
} },
IncludeLinkedAccountsMetrics = false,
Name = "name",
StatisticsConfigurations = new [] { new MetricStreamStatisticsConfigurationProperty {
AdditionalStatistics = new [] { "additionalStatistics" },
IncludeMetrics = new [] { new MetricStreamStatisticsMetricProperty {
MetricName = "metricName",
Namespace = "namespace"
} }
} },
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnMetricStream := awscdk.Aws_cloudwatch.NewCfnMetricStream(this, jsii.String("MyCfnMetricStream"), &CfnMetricStreamProps{
FirehoseArn: jsii.String("firehoseArn"),
OutputFormat: jsii.String("outputFormat"),
RoleArn: jsii.String("roleArn"),
// the properties below are optional
ExcludeFilters: []interface{}{
&MetricStreamFilterProperty{
Namespace: jsii.String("namespace"),
// the properties below are optional
MetricNames: []*string{
jsii.String("metricNames"),
},
},
},
IncludeFilters: []interface{}{
&MetricStreamFilterProperty{
Namespace: jsii.String("namespace"),
// the properties below are optional
MetricNames: []*string{
jsii.String("metricNames"),
},
},
},
IncludeLinkedAccountsMetrics: jsii.Boolean(false),
Name: jsii.String("name"),
StatisticsConfigurations: []interface{}{
&MetricStreamStatisticsConfigurationProperty{
AdditionalStatistics: []*string{
jsii.String("additionalStatistics"),
},
IncludeMetrics: []interface{}{
&MetricStreamStatisticsMetricProperty{
MetricName: jsii.String("metricName"),
Namespace: jsii.String("namespace"),
},
},
},
},
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
})
Initializer
new CfnMetricStream(scope: Construct, id: string, props: CfnMetricStreamProps)
CfnMetricStream(scope: Construct, id: str, props: CfnMetricStreamProps)
new CfnMetricStream(Construct scope, String id, CfnMetricStreamProps props)
new CfnMetricStream(Construct scope, string id, CfnMetricStreamProps props)
NewCfnMetricStream(Scope Construct, Id *string, Props CfnMetricStreamProps)
Construct Props
excludeFiltersoptionalIResolvable | IResolvable | CfnMetricStream.MetricStreamFilterProperty[]exclude_filtersoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MetricStreamFilterProperty]]]excludeFiltersoptionalIResolvableExcludeFiltersoptionalIResolvableExcludeFiltersoptionalinterface{}#notes
You cannot specify both IncludeFilters and ExcludeFilters in the same metric stream.
When you modify the IncludeFilters or ExcludeFilters of an existing metric stream in any way, the metric stream is effectively restarted, so after such a change you will get only the datapoints that have a timestamp after the time of the update.
firehoseArnstring | IDeliveryStreamReffirehose_arntyping.Union[str, IDeliveryStreamRef]firehoseArnStringFirehoseArnstringFirehoseArninterface{}required#This Amazon Kinesis Firehose delivery stream must already exist and must be in the same account as the metric stream.
includeFiltersoptionalIResolvable | IResolvable | CfnMetricStream.MetricStreamFilterProperty[]include_filtersoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MetricStreamFilterProperty]]]includeFiltersoptionalIResolvableIncludeFiltersoptionalIResolvableIncludeFiltersoptionalinterface{}#notes
You cannot specify both IncludeFilters and ExcludeFilters in the same metric stream.
When you modify the IncludeFilters or ExcludeFilters of an existing metric stream in any way, the metric stream is effectively restarted, so after such a change you will get only the datapoints that have a timestamp after the time of the update.
includeLinkedAccountsMetricsoptionalboolean | IResolvableinclude_linked_accounts_metricsoptionaltyping.Union[bool, IResolvable]includeLinkedAccountsMetricsoptionalBooleanIncludeLinkedAccountsMetricsoptionalboolIncludeLinkedAccountsMetricsoptionalinterface{}#The default is false .
For more information about linking accounts, see CloudWatch cross-account observability
The name must be different than the names of other metric streams in this account and Region.
If you are updating a metric stream, specify the name of that stream here.
notes
Valid values are json , opentelemetry1.0 and opentelemetry0.7 For more information about metric stream output formats, see Metric streams output formats .
This parameter is required.
roleArnstring | IRoleRefrole_arntyping.Union[str, IRoleRef]roleArnStringRoleArnstringRoleArninterface{}required#This IAM role must already exist and must be in the same account as the metric stream. This IAM role must include the firehose:PutRecord and firehose:PutRecordBatch permissions.
statisticsConfigurationsoptionalIResolvable | IResolvable | CfnMetricStream.MetricStreamStatisticsConfigurationProperty[]statistics_configurationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MetricStreamStatisticsConfigurationProperty]]]statisticsConfigurationsoptionalIResolvableStatisticsConfigurationsoptionalIResolvableStatisticsConfigurationsoptionalinterface{}#notes
You can use this parameter to have the metric stream also send additional statistics in the stream. This array can have up to 100 members.
For each entry in this array, you specify one or more metrics and the list of additional statistics to stream for those metrics. The additional statistics that you can stream depend on the stream's OutputFormat . If the OutputFormat is json , you can stream any additional statistic that is supported by CloudWatch , listed in CloudWatch statistics definitions . If the OutputFormat is OpenTelemetry, you can stream percentile statistics.
Properties
attrCreationDatestringattr_creation_datestrattrCreationDateStringAttrCreationDatestringAttrCreationDate*string#attrLastUpdateDatestringattr_last_update_datestrattrLastUpdateDateStringAttrLastUpdateDatestringAttrLastUpdateDate*string#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#excludeFiltersmay be undefinedIResolvable | IResolvable | CfnMetricStream.MetricStreamFilterProperty[]exclude_filtersmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MetricStreamFilterProperty]]]excludeFiltersmay be undefinedIResolvableExcludeFiltersmay be undefinedIResolvableExcludeFiltersmay be undefinedinterface{}#includeFiltersmay be undefinedIResolvable | IResolvable | CfnMetricStream.MetricStreamFilterProperty[]include_filtersmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MetricStreamFilterProperty]]]includeFiltersmay be undefinedIResolvableIncludeFiltersmay be undefinedIResolvableIncludeFiltersmay be undefinedinterface{}#includeLinkedAccountsMetricsmay be undefinedboolean | IResolvableinclude_linked_accounts_metricsmay be undefinedtyping.Union[bool, IResolvable]includeLinkedAccountsMetricsmay be undefinedBooleanIncludeLinkedAccountsMetricsmay be undefinedboolIncludeLinkedAccountsMetricsmay be undefinedinterface{}#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
metricStreamRefMetricStreamReferencemetric_stream_refMetricStreamReferencemetricStreamRefMetricStreamReferenceMetricStreamRefMetricStreamReferenceMetricStreamRefMetricStreamReference#namemay be undefinedstringnamemay be undefinedstrnamemay be undefinedStringNamemay be undefinedstringNamemay be undefined*string#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
statisticsConfigurationsmay be undefinedIResolvable | IResolvable | CfnMetricStream.MetricStreamStatisticsConfigurationProperty[]statistics_configurationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MetricStreamStatisticsConfigurationProperty]]]statisticsConfigurationsmay be undefinedIResolvableStatisticsConfigurationsmay be undefinedIResolvableStatisticsConfigurationsmay be undefinedinterface{}#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForMetricStream(resource: IMetricStreamRef): string@staticmethod def arn_for_metric_stream(resource: IMetricStreamRef) -> strpublic static String arnForMetricStream(IMetricStreamRef resource)public static string ArnForMetricStream(IMetricStreamRef resource)func ArnForMetricStream(Resource IMetricStreamRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#fromMetricStreamArn(scope: Construct, id: string, arn: string): IMetricStreamRef@staticmethod def from_metric_stream_arn(scope: Construct, id: str, arn: str) -> IMetricStreamRefpublic static IMetricStreamRef fromMetricStreamArn(Construct scope, String id, String arn)public static IMetricStreamRef FromMetricStreamArn(Construct scope, string id, string arn)func FromMetricStreamArn(Scope Construct, Id *string, Arn *string) IMetricStreamRefstatic#fromMetricStreamName(scope: Construct, id: string, metricStreamName: string): IMetricStreamRef@staticmethod def from_metric_stream_name(scope: Construct, id: str, metric_stream_name: str) -> IMetricStreamRefpublic static IMetricStreamRef fromMetricStreamName(Construct scope, String id, String metricStreamName)public static IMetricStreamRef FromMetricStreamName(Construct scope, string id, string metricStreamName)func FromMetricStreamName(Scope Construct, Id *string, MetricStreamName *string) IMetricStreamRefstatic#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnMetricStream(x: any): boolean@staticmethod def is_cfn_metric_stream(x: Any) -> boolpublic static Boolean isCfnMetricStream(Object x)public static bool IsCfnMetricStream(object x)func IsCfnMetricStream(X interface{}) *boolstatic#isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.